(set-logic HORN)
(declare-fun invariant (Real Real Bool Bool Bool Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real Real) Bool)

;; Initial state
(assert
  (forall ((state.cal!content Real) (state.cal!delivery Real) (state.cal!flag!0 Bool) (state.cal!flag!1 Bool) (state.cal!flag!2 Bool) (state.cal!origin Real) (state.cal!send Real) (state.pc!0 Real) (state.pc!1 Real) (state.pc!2 Real) (state.slot!0 Real) (state.slot!1 Real) (state.slot!2 Real) (state.slot!3 Real) (state.slot!4 Real) (state.slot!5 Real) (state.slot!6 Real) (state.slot!7 Real) (state.slot!8 Real) (state.slot!9 Real) (state.time Real) (state.time_out!0 Real) (state.time_out!1 Real) (state.time_out!2 Real) (state.time_out!3 Real) (state.time_out!4 Real) (state.time_out!5 Real) (state.time_out!6 Real) (state.time_out!7 Real) (state.time_out!8 Real) (state.time_out!9 Real) (state.propagation Real))
    (=> (and (and (= state.time 0) (= state.pc!0 0) (= state.pc!1 0) (= state.pc!2 0) (and (< state.time state.time_out!0) (< state.time_out!0 30)) (and (< state.time state.time_out!1) (< state.time_out!1 30)) (and (< state.time state.time_out!2) (< state.time_out!2 30)) (= state.cal!content 1) (= state.cal!delivery 0) (= state.cal!flag!0 false) (= state.cal!flag!1 false) (= state.cal!flag!2 false) (= state.cal!origin 1) (= state.cal!send 0)) (and (or (= state.cal!content 0) (= state.cal!content 1)) (or (= state.cal!origin 1) (= state.cal!origin 2) (= state.cal!origin 3)) (or (= state.pc!0 0) (= state.pc!0 1) (= state.pc!0 2) (= state.pc!0 3)) (or (= state.pc!1 0) (= state.pc!1 1) (= state.pc!1 2) (= state.pc!1 3)) (or (= state.pc!2 0) (= state.pc!2 1) (= state.pc!2 2) (= state.pc!2 3)) (or (= state.slot!0 1) (= state.slot!0 2) (= state.slot!0 3)) (or (= state.slot!1 1) (= state.slot!1 2) (= state.slot!1 3)) (or (= state.slot!2 1) (= state.slot!2 2) (= state.slot!2 3))))
        (invariant state.cal!content state.cal!delivery state.cal!flag!0 state.cal!flag!1 state.cal!flag!2 state.cal!origin state.cal!send state.pc!0 state.pc!1 state.pc!2 state.slot!0 state.slot!1 state.slot!2 state.slot!3 state.slot!4 state.slot!5 state.slot!6 state.slot!7 state.slot!8 state.slot!9 state.time state.time_out!0 state.time_out!1 state.time_out!2 state.time_out!3 state.time_out!4 state.time_out!5 state.time_out!6 state.time_out!7 state.time_out!8 state.time_out!9 state.propagation))
  )
)

;; Transition relation state
(assert
  (forall ((state.cal!content Real) (next.cal!content Real) (state.cal!delivery Real) (next.cal!delivery Real) (state.cal!flag!0 Bool) (next.cal!flag!0 Bool) (state.cal!flag!1 Bool) (next.cal!flag!1 Bool) (state.cal!flag!2 Bool) (next.cal!flag!2 Bool) (state.cal!origin Real) (next.cal!origin Real) (state.cal!send Real) (next.cal!send Real) (state.pc!0 Real) (next.pc!0 Real) (state.pc!1 Real) (next.pc!1 Real) (state.pc!2 Real) (next.pc!2 Real) (state.slot!0 Real) (next.slot!0 Real) (state.slot!1 Real) (next.slot!1 Real) (state.slot!2 Real) (next.slot!2 Real) (state.slot!3 Real) (next.slot!3 Real) (state.slot!4 Real) (next.slot!4 Real) (state.slot!5 Real) (next.slot!5 Real) (state.slot!6 Real) (next.slot!6 Real) (state.slot!7 Real) (next.slot!7 Real) (state.slot!8 Real) (next.slot!8 Real) (state.slot!9 Real) (next.slot!9 Real) (state.time Real) (next.time Real) (state.time_out!0 Real) (next.time_out!0 Real) (state.time_out!1 Real) (next.time_out!1 Real) (state.time_out!2 Real) (next.time_out!2 Real) (state.time_out!3 Real) (next.time_out!3 Real) (state.time_out!4 Real) (next.time_out!4 Real) (state.time_out!5 Real) (next.time_out!5 Real) (state.time_out!6 Real) (next.time_out!6 Real) (state.time_out!7 Real) (next.time_out!7 Real) (state.time_out!8 Real) (next.time_out!8 Real) (state.time_out!9 Real) (next.time_out!9 Real) (state.propagation Real) (next.propagation Real))
    (=> (and (invariant state.cal!content state.cal!delivery state.cal!flag!0 state.cal!flag!1 state.cal!flag!2 state.cal!origin state.cal!send state.pc!0 state.pc!1 state.pc!2 state.slot!0 state.slot!1 state.slot!2 state.slot!3 state.slot!4 state.slot!5 state.slot!6 state.slot!7 state.slot!8 state.slot!9 state.time state.time_out!0 state.time_out!1 state.time_out!2 state.time_out!3 state.time_out!4 state.time_out!5 state.time_out!6 state.time_out!7 state.time_out!8 state.time_out!9 state.propagation)
             (and (and (= next.propagation state.propagation) (or (and (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (and (< state.time state.time_out!0) (< state.time state.time_out!1) (< state.time state.time_out!2)) (and (< state.time state.time_out!0) (< state.time state.time_out!1) (< state.time state.time_out!2) (< state.time state.cal!delivery))) (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (and (<= next.time state.time_out!0) (<= next.time state.time_out!1) (<= next.time state.time_out!2) (or (= next.time state.time_out!0) (= next.time state.time_out!1) (= next.time state.time_out!2))) (and (<= next.time state.time_out!0) (<= next.time state.time_out!1) (<= next.time state.time_out!2) (<= next.time state.cal!delivery) (or (= next.time state.cal!delivery) (= next.time state.time_out!0) (= next.time state.time_out!1) (= next.time state.time_out!2)))) (= next.pc!0 state.pc!0) (= next.pc!1 state.pc!1) (= next.pc!2 state.pc!2) (= next.slot!0 state.slot!0) (= next.slot!1 state.slot!1) (= next.slot!2 state.slot!2) (= next.time_out!0 state.time_out!0) (= next.time_out!1 state.time_out!1) (= next.time_out!2 state.time_out!2) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send))) (and (or (and (or (and (= state.pc!0 0) (= state.time state.time_out!0) (= next.pc!0 1) (= next.time_out!0 (+ state.time 18)) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.slot!0 state.slot!0)) (and (= state.pc!0 0) state.cal!flag!0 (= state.time state.cal!delivery) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 false) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!0 state.pc!0) (= next.slot!0 state.slot!0) (= next.time_out!0 state.time_out!0)) (and (= state.pc!0 1) (= state.time state.time_out!0) (= next.pc!0 2) (= next.time_out!0 (+ state.time 9)) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 0 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 false) (= next.cal!flag!1 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!1)) (= next.cal!flag!2 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!2)) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 1 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.slot!0 state.slot!0)) (and (= state.pc!0 1) state.cal!flag!0 (= state.cal!content 0) (= state.time state.cal!delivery) (= next.pc!0 2) (= next.time_out!0 (- (+ state.time 9) state.propagation)) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 false) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.slot!0 state.slot!0)) (and (= state.pc!0 2) state.cal!flag!0 (= state.cal!content 0) (= state.time state.cal!delivery) (= next.pc!0 3) (= next.time_out!0 (- (+ state.time 3) state.propagation)) (= next.slot!0 state.cal!origin) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 false) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send))) (and (= state.pc!0 2) (= state.time state.time_out!0) (= next.time_out!0 (+ state.time 9)) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 0 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 false) (= next.cal!flag!1 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!1)) (= next.cal!flag!2 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!2)) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 1 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.pc!0 state.pc!0) (= next.slot!0 state.slot!0)) (and (or (= state.pc!0 1) (= state.pc!0 2)) state.cal!flag!0 (= state.cal!content 1) (= state.time state.cal!delivery) (= next.pc!0 3) (= next.time_out!0 (- (+ state.time 3) state.propagation)) (= next.slot!0 state.cal!origin) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 false) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send))) (and (= state.pc!0 3) (= state.time state.time_out!0) (not (= (ite (= state.slot!0 3) 1 (+ state.slot!0 1)) 1)) (= next.time_out!0 (+ state.time 3)) (= next.slot!0 (ite (= state.slot!0 3) 1 (+ state.slot!0 1))) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!0 state.pc!0)) (and (= state.pc!0 3) (= state.time state.time_out!0) (= (ite (= state.slot!0 3) 1 (+ state.slot!0 1)) 1) (= next.time_out!0 (+ state.time 3)) (= next.slot!0 (ite (= state.slot!0 3) 1 (+ state.slot!0 1))) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 1 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 false) (= next.cal!flag!1 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!1)) (= next.cal!flag!2 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!2)) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 1 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.pc!0 state.pc!0)) (and (= state.pc!0 3) state.cal!flag!0 (= state.cal!content 1) (= state.time state.cal!delivery) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 false) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!0 state.pc!0) (= next.slot!0 state.slot!0) (= next.time_out!0 state.time_out!0))) (= next.pc!1 state.pc!1) (= next.slot!1 state.slot!1) (= next.time_out!1 state.time_out!1) (= next.pc!2 state.pc!2) (= next.slot!2 state.slot!2) (= next.time_out!2 state.time_out!2)) (and (or (and (= state.pc!1 0) (= state.time state.time_out!1) (= next.pc!1 1) (= next.time_out!1 (+ state.time 21)) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.slot!1 state.slot!1)) (and (= state.pc!1 0) state.cal!flag!1 (= state.time state.cal!delivery) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 false) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!1 state.pc!1) (= next.slot!1 state.slot!1) (= next.time_out!1 state.time_out!1)) (and (= state.pc!1 1) (= state.time state.time_out!1) (= next.pc!1 2) (= next.time_out!1 (+ state.time 12)) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 0 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!0)) (= next.cal!flag!1 false) (= next.cal!flag!2 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!2)) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 2 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.slot!1 state.slot!1)) (and (= state.pc!1 1) state.cal!flag!1 (= state.cal!content 0) (= state.time state.cal!delivery) (= next.pc!1 2) (= next.time_out!1 (- (+ state.time 12) state.propagation)) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 false) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.slot!1 state.slot!1)) (and (= state.pc!1 2) state.cal!flag!1 (= state.cal!content 0) (= state.time state.cal!delivery) (= next.pc!1 3) (= next.time_out!1 (- (+ state.time 3) state.propagation)) (= next.slot!1 state.cal!origin) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 false) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send))) (and (= state.pc!1 2) (= state.time state.time_out!1) (= next.time_out!1 (+ state.time 12)) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 0 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!0)) (= next.cal!flag!1 false) (= next.cal!flag!2 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!2)) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 2 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.pc!1 state.pc!1) (= next.slot!1 state.slot!1)) (and (or (= state.pc!1 1) (= state.pc!1 2)) state.cal!flag!1 (= state.cal!content 1) (= state.time state.cal!delivery) (= next.pc!1 3) (= next.time_out!1 (- (+ state.time 3) state.propagation)) (= next.slot!1 state.cal!origin) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 false) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send))) (and (= state.pc!1 3) (= state.time state.time_out!1) (not (= (ite (= state.slot!1 3) 1 (+ state.slot!1 1)) 2)) (= next.time_out!1 (+ state.time 3)) (= next.slot!1 (ite (= state.slot!1 3) 1 (+ state.slot!1 1))) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!1 state.pc!1)) (and (= state.pc!1 3) (= state.time state.time_out!1) (= (ite (= state.slot!1 3) 1 (+ state.slot!1 1)) 2) (= next.time_out!1 (+ state.time 3)) (= next.slot!1 (ite (= state.slot!1 3) 1 (+ state.slot!1 1))) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 1 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!0)) (= next.cal!flag!1 false) (= next.cal!flag!2 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!2)) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 2 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.pc!1 state.pc!1)) (and (= state.pc!1 3) state.cal!flag!1 (= state.cal!content 1) (= state.time state.cal!delivery) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 false) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!1 state.pc!1) (= next.slot!1 state.slot!1) (= next.time_out!1 state.time_out!1))) (= next.pc!0 state.pc!0) (= next.slot!0 state.slot!0) (= next.time_out!0 state.time_out!0) (= next.pc!2 state.pc!2) (= next.slot!2 state.slot!2) (= next.time_out!2 state.time_out!2)) (and (or (and (= state.pc!2 0) (= state.time state.time_out!2) (= next.pc!2 1) (= next.time_out!2 (+ state.time 24)) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.slot!2 state.slot!2)) (and (= state.pc!2 0) state.cal!flag!2 (= state.time state.cal!delivery) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 false) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!2 state.pc!2) (= next.slot!2 state.slot!2) (= next.time_out!2 state.time_out!2)) (and (= state.pc!2 1) (= state.time state.time_out!2) (= next.pc!2 2) (= next.time_out!2 (+ state.time 15)) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 0 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!0)) (= next.cal!flag!1 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!1)) (= next.cal!flag!2 false) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 3 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.slot!2 state.slot!2)) (and (= state.pc!2 1) state.cal!flag!2 (= state.cal!content 0) (= state.time state.cal!delivery) (= next.pc!2 2) (= next.time_out!2 (- (+ state.time 15) state.propagation)) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 false) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.slot!2 state.slot!2)) (and (= state.pc!2 2) state.cal!flag!2 (= state.cal!content 0) (= state.time state.cal!delivery) (= next.pc!2 3) (= next.time_out!2 (- (+ state.time 3) state.propagation)) (= next.slot!2 state.cal!origin) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 false) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send))) (and (= state.pc!2 2) (= state.time state.time_out!2) (= next.time_out!2 (+ state.time 15)) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 0 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!0)) (= next.cal!flag!1 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!1)) (= next.cal!flag!2 false) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 3 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.pc!2 state.pc!2) (= next.slot!2 state.slot!2)) (and (or (= state.pc!2 1) (= state.pc!2 2)) state.cal!flag!2 (= state.cal!content 1) (= state.time state.cal!delivery) (= next.pc!2 3) (= next.time_out!2 (- (+ state.time 3) state.propagation)) (= next.slot!2 state.cal!origin) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 false) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send))) (and (= state.pc!2 3) (= state.time state.time_out!2) (not (= (ite (= state.slot!2 3) 1 (+ state.slot!2 1)) 3)) (= next.time_out!2 (+ state.time 3)) (= next.slot!2 (ite (= state.slot!2 3) 1 (+ state.slot!2 1))) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 state.cal!flag!2) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!2 state.pc!2)) (and (= state.pc!2 3) (= state.time state.time_out!2) (= (ite (= state.slot!2 3) 1 (+ state.slot!2 1)) 3) (= next.time_out!2 (+ state.time 3)) (= next.slot!2 (ite (= state.slot!2 3) 1 (+ state.slot!2 1))) (= next.cal!content (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 1 state.cal!content)) (= next.cal!delivery (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) (+ state.time state.propagation) state.cal!delivery)) (= next.cal!flag!0 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!0)) (= next.cal!flag!1 (or (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.cal!flag!1)) (= next.cal!flag!2 false) (= next.cal!origin (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) 3 state.cal!origin)) (= next.cal!send (ite (and (not state.cal!flag!0) (not state.cal!flag!1) (not state.cal!flag!2)) state.time state.cal!send)) (= next.pc!2 state.pc!2)) (and (= state.pc!2 3) state.cal!flag!2 (= state.cal!content 1) (= state.time state.cal!delivery) (and (= next.cal!content state.cal!content) (= next.cal!delivery state.cal!delivery) (= next.cal!flag!0 state.cal!flag!0) (= next.cal!flag!1 state.cal!flag!1) (= next.cal!flag!2 false) (= next.cal!origin state.cal!origin) (= next.cal!send state.cal!send)) (= next.pc!2 state.pc!2) (= next.slot!2 state.slot!2) (= next.time_out!2 state.time_out!2))) (= next.pc!0 state.pc!0) (= next.slot!0 state.slot!0) (= next.time_out!0 state.time_out!0) (= next.pc!1 state.pc!1) (= next.slot!1 state.slot!1) (= next.time_out!1 state.time_out!1))) (= next.time state.time)))) (and (or (= state.cal!content 0) (= state.cal!content 1)) (or (= state.cal!origin 1) (= state.cal!origin 2) (= state.cal!origin 3)) (or (= state.pc!0 0) (= state.pc!0 1) (= state.pc!0 2) (= state.pc!0 3)) (or (= state.pc!1 0) (= state.pc!1 1) (= state.pc!1 2) (= state.pc!1 3)) (or (= state.pc!2 0) (= state.pc!2 1) (= state.pc!2 2) (= state.pc!2 3)) (or (= state.slot!0 1) (= state.slot!0 2) (= state.slot!0 3)) (or (= state.slot!1 1) (= state.slot!1 2) (= state.slot!1 3)) (or (= state.slot!2 1) (= state.slot!2 2) (= state.slot!2 3))) (and (or (= next.cal!content 0) (= next.cal!content 1)) (or (= next.cal!origin 1) (= next.cal!origin 2) (= next.cal!origin 3)) (or (= next.pc!0 0) (= next.pc!0 1) (= next.pc!0 2) (= next.pc!0 3)) (or (= next.pc!1 0) (= next.pc!1 1) (= next.pc!1 2) (= next.pc!1 3)) (or (= next.pc!2 0) (= next.pc!2 1) (= next.pc!2 2) (= next.pc!2 3)) (or (= next.slot!0 1) (= next.slot!0 2) (= next.slot!0 3)) (or (= next.slot!1 1) (= next.slot!1 2) (= next.slot!1 3)) (or (= next.slot!2 1) (= next.slot!2 2) (= next.slot!2 3))))
        )
        (invariant next.cal!content next.cal!delivery next.cal!flag!0 next.cal!flag!1 next.cal!flag!2 next.cal!origin next.cal!send next.pc!0 next.pc!1 next.pc!2 next.slot!0 next.slot!1 next.slot!2 next.slot!3 next.slot!4 next.slot!5 next.slot!6 next.slot!7 next.slot!8 next.slot!9 next.time next.time_out!0 next.time_out!1 next.time_out!2 next.time_out!3 next.time_out!4 next.time_out!5 next.time_out!6 next.time_out!7 next.time_out!8 next.time_out!9 next.propagation)
    )
  )
)

;; Property
(assert
  (forall ((state.cal!content Real) (state.cal!delivery Real) (state.cal!flag!0 Bool) (state.cal!flag!1 Bool) (state.cal!flag!2 Bool) (state.cal!origin Real) (state.cal!send Real) (state.pc!0 Real) (state.pc!1 Real) (state.pc!2 Real) (state.slot!0 Real) (state.slot!1 Real) (state.slot!2 Real) (state.slot!3 Real) (state.slot!4 Real) (state.slot!5 Real) (state.slot!6 Real) (state.slot!7 Real) (state.slot!8 Real) (state.slot!9 Real) (state.time Real) (state.time_out!0 Real) (state.time_out!1 Real) (state.time_out!2 Real) (state.time_out!3 Real) (state.time_out!4 Real) (state.time_out!5 Real) (state.time_out!6 Real) (state.time_out!7 Real) (state.time_out!8 Real) (state.time_out!9 Real) (state.propagation Real))
    (=> (invariant state.cal!content state.cal!delivery state.cal!flag!0 state.cal!flag!1 state.cal!flag!2 state.cal!origin state.cal!send state.pc!0 state.pc!1 state.pc!2 state.slot!0 state.slot!1 state.slot!2 state.slot!3 state.slot!4 state.slot!5 state.slot!6 state.slot!7 state.slot!8 state.slot!9 state.time state.time_out!0 state.time_out!1 state.time_out!2 state.time_out!3 state.time_out!4 state.time_out!5 state.time_out!6 state.time_out!7 state.time_out!8 state.time_out!9 state.propagation)
        (and (or (not (= state.pc!0 3)) (not (< state.time state.time_out!0)) (and (or (not (= state.pc!1 3)) (not (< state.time state.time_out!1)) (and (= state.time_out!0 state.time_out!1) (= state.slot!0 state.slot!1))) (or (not (= state.pc!2 3)) (not (< state.time state.time_out!2)) (and (= state.time_out!0 state.time_out!2) (= state.slot!0 state.slot!2))))) (or (not (= state.pc!1 3)) (not (< state.time state.time_out!1)) (and (or (not (= state.pc!0 3)) (not (< state.time state.time_out!0)) (and (= state.time_out!1 state.time_out!0) (= state.slot!1 state.slot!0))) (or (not (= state.pc!2 3)) (not (< state.time state.time_out!2)) (and (= state.time_out!1 state.time_out!2) (= state.slot!1 state.slot!2))))) (or (not (= state.pc!2 3)) (not (< state.time state.time_out!2)) (and (or (not (= state.pc!0 3)) (not (< state.time state.time_out!0)) (and (= state.time_out!2 state.time_out!0) (= state.slot!2 state.slot!0))) (or (not (= state.pc!1 3)) (not (< state.time state.time_out!1)) (and (= state.time_out!2 state.time_out!1) (= state.slot!2 state.slot!1))))))
    )
  )
)

;; Check the property
(check-sat)
